diff --git a/third_party/rust/clang-sys/src/support.rs b/third_party/rust/clang-sys/src/support.rs
index 1e223086400b..68d912d57e40 100644
--- a/third_party/rust/clang-sys/src/support.rs
+++ b/third_party/rust/clang-sys/src/support.rs
@@ -58,22 +58,17 @@ pub struct Clang {
 
 impl Clang {
     //- Constructors -----------------------------
 
     fn new(path: PathBuf, args: &[String]) -> Clang {
         let version = parse_version(&path);
         let c_search_paths = parse_search_paths(&path, "c", args);
         let cpp_search_paths = parse_search_paths(&path, "c++", args);
-        Clang {
-            path: path,
-            version: version,
-            c_search_paths: c_search_paths,
-            cpp_search_paths: cpp_search_paths,
-        }
+        Clang { path, version, c_search_paths, cpp_search_paths }
     }
 
     /// Returns a `clang` executable if one can be found.
     ///
     /// If the `CLANG_PATH` environment variable is set, that is the instance of `clang` used.
     /// Otherwise, a series of directories are searched. First, If a path is supplied, that is the
     /// first directory searched. Then, the directory returned by `llvm-config --bindir` is
     /// searched. On OS X systems, `xcodebuild -find clang` will next be queried. Last, the
@@ -143,17 +138,17 @@ fn is_executable(_: &Path) -> io::Result<bool> {
 }
 
 /// Attempts to run an executable, returning the `stdout` and `stderr` output if successful.
 fn run(executable: &str, arguments: &[&str]) -> Result<(String, String), String> {
     Command::new(executable).args(arguments).output().map(|o| {
         let stdout = String::from_utf8_lossy(&o.stdout).into_owned();
         let stderr = String::from_utf8_lossy(&o.stderr).into_owned();
         (stdout, stderr)
-    }).map_err(|_| format!("could not run executable: `{}`", executable))
+    }).map_err(|e| format!("could not run executable `{}`: {}", executable, e))
 }
 
 /// Runs `clang`, returning the `stdout` and `stderr` output.
 fn run_clang(path: &Path, arguments: &[&str]) -> (String, String) {
     run(&path.to_string_lossy().into_owned(), arguments).unwrap()
 }
 
 /// Runs `llvm-config`, returning the `stdout` output if successful.
diff --git a/third_party/rust/libc/Cargo.toml b/third_party/rust/libc/Cargo.toml
index 16f0ad234cd7..876b127c08f6 100644
--- a/third_party/rust/libc/Cargo.toml
+++ b/third_party/rust/libc/Cargo.toml
@@ -7,26 +7,27 @@
 #
 # If you believe there's an error in this file please file an
 # issue against the rust-lang/cargo repository. If you're
 # editing this file be aware that the upstream Cargo.toml
 # will likely look very different (and much more reasonable)
 
 [package]
 name = "libc"
-version = "0.2.33"
+version = "0.2.43"
 authors = ["The Rust Project Developers"]
 description = "A library for types and bindings to native C functions often found in libc or\nother common platform libraries.\n"
 homepage = "https://github.com/rust-lang/libc"
 documentation = "http://doc.rust-lang.org/libc"
 readme = "README.md"
 license = "MIT/Apache-2.0"
 repository = "https://github.com/rust-lang/libc"
 
 [features]
+align = []
 default = ["use_std"]
 use_std = []
 [badges.appveyor]
-repository = "rust-lang/libc"
 project_name = "rust-lang-libs/libc"
+repository = "rust-lang/libc"
 
 [badges.travis-ci]
 repository = "rust-lang/libc"
diff --git a/third_party/rust/libc/ci/docker/aarch64-unknown-linux-musl/Dockerfile b/third_party/rust/libc/ci/docker/aarch64-unknown-linux-musl/Dockerfile
index e86c4c0ae3d2..caec1572cbb9 100644
--- a/third_party/rust/libc/ci/docker/aarch64-unknown-linux-musl/Dockerfile
+++ b/third_party/rust/libc/ci/docker/aarch64-unknown-linux-musl/Dockerfile
@@ -1,27 +1,27 @@
 FROM ubuntu:17.10
 
 RUN apt-get update && apt-get install -y --no-install-recommends \
   gcc make libc6-dev git curl ca-certificates \
   gcc-aarch64-linux-gnu qemu-user
-RUN curl https://www.musl-libc.org/releases/musl-1.1.16.tar.gz | \
+RUN curl https://www.musl-libc.org/releases/musl-1.1.19.tar.gz | \
     tar xzf - && \
-    cd musl-1.1.16 && \
+    cd musl-1.1.19 && \
     CC=aarch64-linux-gnu-gcc \
     ./configure --prefix=/musl-aarch64 --enable-wrapper=yes && \
     make install -j4 && \
     cd .. && \
-    rm -rf musl-1.1.16 && \
+    rm -rf musl-1.1.19
 # Install linux kernel headers sanitized for use with musl
-    curl -L  https://github.com/sabotage-linux/kernel-headers/archive/v3.12.6-5.tar.gz | \
+RUN curl -L  https://github.com/sabotage-linux/kernel-headers/archive/v3.12.6-6.tar.gz | \
     tar xzf - && \
-    cd kernel-headers-3.12.6-5 && \
+    cd kernel-headers-3.12.6-6 && \
     make ARCH=arm64 prefix=/musl-aarch64 install -j4 && \
     cd .. && \
-    rm -rf kernel-headers-3.12.6-5
+    rm -rf kernel-headers-3.12.6-6
 
 # FIXME: shouldn't need the `-lgcc` here, shouldn't that be in libstd?
 ENV PATH=$PATH:/musl-aarch64/bin:/rust/bin \
     CC_aarch64_unknown_linux_musl=musl-gcc \
     RUSTFLAGS='-Clink-args=-lgcc' \
     CARGO_TARGET_AARCH64_UNKNOWN_LINUX_MUSL_LINKER=musl-gcc \
     CARGO_TARGET_AARCH64_UNKNOWN_LINUX_MUSL_RUNNER="qemu-aarch64 -L /musl-aarch64"
diff --git a/third_party/rust/libc/ci/docker/arm-unknown-linux-musleabihf/Dockerfile b/third_party/rust/libc/ci/docker/arm-unknown-linux-musleabihf/Dockerfile
index 130730b99733..86304130fe30 100644
--- a/third_party/rust/libc/ci/docker/arm-unknown-linux-musleabihf/Dockerfile
+++ b/third_party/rust/libc/ci/docker/arm-unknown-linux-musleabihf/Dockerfile
@@ -1,25 +1,25 @@
 FROM ubuntu:17.10
 
 RUN apt-get update && apt-get install -y --no-install-recommends \
   gcc make libc6-dev git curl ca-certificates \
   gcc-arm-linux-gnueabihf qemu-user
 
-RUN curl https://www.musl-libc.org/releases/musl-1.1.16.tar.gz | tar xzf -
-WORKDIR /musl-1.1.16
+RUN curl https://www.musl-libc.org/releases/musl-1.1.19.tar.gz | tar xzf -
+WORKDIR /musl-1.1.19
 RUN CC=arm-linux-gnueabihf-gcc \
     CFLAGS="-march=armv6 -marm" \
     ./configure --prefix=/musl-arm --enable-wrapper=yes
 RUN make install -j4
 
 # Install linux kernel headers sanitized for use with musl
-RUN \
-    curl -L  https://github.com/sabotage-linux/kernel-headers/archive/v3.12.6-5.tar.gz | \
+RUN curl -L  https://github.com/sabotage-linux/kernel-headers/archive/v3.12.6-6.tar.gz | \
     tar xzf - && \
-    cd kernel-headers-3.12.6-5 && \
+    cd kernel-headers-3.12.6-6 && \
     make ARCH=arm prefix=/musl-arm install -j4 && \
     cd .. && \
-    rm -rf kernel-headers-3.12.6-5
+    rm -rf kernel-headers-3.12.6-6
+
 ENV PATH=$PATH:/musl-arm/bin:/rust/bin \
     CC_arm_unknown_linux_musleabihf=musl-gcc \
     CARGO_TARGET_ARM_UNKNOWN_LINUX_MUSLEABIHF_LINKER=musl-gcc \
     CARGO_TARGET_ARM_UNKNOWN_LINUX_MUSLEABIHF_RUNNER="qemu-arm -L /musl-arm"
diff --git a/third_party/rust/libc/ci/docker/i686-unknown-linux-gnu/Dockerfile b/third_party/rust/libc/ci/docker/i686-unknown-linux-gnu/Dockerfile
index 1af41343e268..03f3e8e690e3 100644
--- a/third_party/rust/libc/ci/docker/i686-unknown-linux-gnu/Dockerfile
+++ b/third_party/rust/libc/ci/docker/i686-unknown-linux-gnu/Dockerfile
@@ -1,5 +1,5 @@
-FROM ubuntu:17.04
+FROM ubuntu:18.04
 RUN apt-get update
 RUN apt-get install -y --no-install-recommends \
   gcc-multilib libc6-dev ca-certificates
 ENV PATH=$PATH:/rust/bin
diff --git a/third_party/rust/libc/ci/docker/i686-unknown-linux-musl/Dockerfile b/third_party/rust/libc/ci/docker/i686-unknown-linux-musl/Dockerfile
index 3adb92004084..49f37d70f2af 100644
--- a/third_party/rust/libc/ci/docker/i686-unknown-linux-musl/Dockerfile
+++ b/third_party/rust/libc/ci/docker/i686-unknown-linux-musl/Dockerfile
@@ -7,24 +7,25 @@ RUN apt-get install -y --no-install-recommends \
 # Below we're cross-compiling musl for i686 using the system compiler on an
 # x86_64 system. This is an awkward thing to be doing and so we have to jump
 # through a couple hoops to get musl to be happy. In particular:
 #
 # * We specifically pass -m32 in CFLAGS and override CC when running ./configure,
 #   since otherwise the script will fail to find a compiler.
 # * We manually unset CROSS_COMPILE when running make; otherwise the makefile
 #   will call the non-existent binary 'i686-ar'.
-RUN curl https://www.musl-libc.org/releases/musl-1.1.15.tar.gz | \
+RUN curl https://www.musl-libc.org/releases/musl-1.1.19.tar.gz | \
     tar xzf - && \
-    cd musl-1.1.15 && \
+    cd musl-1.1.19 && \
     CC=gcc CFLAGS=-m32 ./configure --prefix=/musl-i686 --disable-shared --target=i686 && \
     make CROSS_COMPILE= install -j4 && \
     cd .. && \
-    rm -rf musl-1.1.15 && \
+    rm -rf musl-1.1.19
 # Install linux kernel headers sanitized for use with musl
-    curl -L  https://github.com/sabotage-linux/kernel-headers/archive/v3.12.6-5.tar.gz | \
+RUN curl -L  https://github.com/sabotage-linux/kernel-headers/archive/v3.12.6-6.tar.gz | \
     tar xzf - && \
-    cd kernel-headers-3.12.6-5 && \
+    cd kernel-headers-3.12.6-6 && \
     make ARCH=i386 prefix=/musl-i686 install -j4 && \
     cd .. && \
-    rm -rf kernel-headers-3.12.6-5
+    rm -rf kernel-headers-3.12.6-6
+
 ENV PATH=$PATH:/musl-i686/bin:/rust/bin \
     CC_i686_unknown_linux_musl=musl-gcc
diff --git a/third_party/rust/libc/ci/docker/s390x-unknown-linux-gnu/Dockerfile b/third_party/rust/libc/ci/docker/s390x-unknown-linux-gnu/Dockerfile
index 49a277d884f5..861f4f9b00ee 100644
--- a/third_party/rust/libc/ci/docker/s390x-unknown-linux-gnu/Dockerfile
+++ b/third_party/rust/libc/ci/docker/s390x-unknown-linux-gnu/Dockerfile
@@ -1,12 +1,18 @@
 FROM ubuntu:17.10
 
 RUN apt-get update && apt-get install -y --no-install-recommends \
-        gcc libc6-dev qemu-user ca-certificates \
-        gcc-s390x-linux-gnu libc6-dev-s390x-cross
+        curl ca-certificates \
+        gcc libc6-dev \
+        gcc-s390x-linux-gnu libc6-dev-s390x-cross \
+        qemu-system-s390x \
+        cpio
+
+COPY linux-s390x.sh /
+RUN bash /linux-s390x.sh
+
+COPY test-runner-linux /
 
 ENV CARGO_TARGET_S390X_UNKNOWN_LINUX_GNU_LINKER=s390x-linux-gnu-gcc \
-    # TODO: in theory we should execute this, but qemu segfaults immediately :(
-    # CARGO_TARGET_S390X_UNKNOWN_LINUX_GNU_RUNNER="qemu-s390x -L /usr/s390x-linux-gnu" \
-    CARGO_TARGET_S390X_UNKNOWN_LINUX_GNU_RUNNER=true \
+    CARGO_TARGET_S390X_UNKNOWN_LINUX_GNU_RUNNER="/test-runner-linux s390x" \
     CC_s390x_unknown_linux_gnu=s390x-linux-gnu-gcc \
     PATH=$PATH:/rust/bin
diff --git a/third_party/rust/libc/ci/docker/sparc64-unknown-linux-gnu/Dockerfile b/third_party/rust/libc/ci/docker/sparc64-unknown-linux-gnu/Dockerfile
index 2d53371add9c..d9edaab42635 100644
--- a/third_party/rust/libc/ci/docker/sparc64-unknown-linux-gnu/Dockerfile
+++ b/third_party/rust/libc/ci/docker/sparc64-unknown-linux-gnu/Dockerfile
@@ -1,14 +1,21 @@
-# link fails on 17.10
-FROM ubuntu:17.04
+FROM debian:stretch
 
 RUN apt-get update && apt-get install -y --no-install-recommends \
-        gcc libc6-dev qemu-user ca-certificates \
-        gcc-sparc64-linux-gnu libc6-dev-sparc64-cross
+        curl ca-certificates \
+        gcc libc6-dev \
+        gcc-sparc64-linux-gnu libc6-dev-sparc64-cross \
+        qemu-system-sparc64 openbios-sparc seabios ipxe-qemu \
+        p7zip-full cpio linux-libc-dev-sparc64-cross linux-headers-4.9.0-3-common
+
+# Put linux/module.h into the right spot as it is not shipped by debian
+RUN cp /usr/src/linux-headers-4.9.0-3-common/include/uapi/linux/module.h /usr/sparc64-linux-gnu/include/linux/
+
+COPY linux-sparc64.sh /
+RUN bash /linux-sparc64.sh
+
+COPY test-runner-linux /
 
 ENV CARGO_TARGET_SPARC64_UNKNOWN_LINUX_GNU_LINKER=sparc64-linux-gnu-gcc \
-    # TODO: in theory we should execute this, but qemu segfaults immediately
-    #       see https://github.com/rust-lang/libc/issues/822
-    # CARGO_TARGET_SPARC64_UNKNOWN_LINUX_GNU_RUNNER="qemu-sparc64 -L /usr/sparc64-linux-gnu" \
-    CARGO_TARGET_SPARC64_UNKNOWN_LINUX_GNU_RUNNER=true \
+    CARGO_TARGET_SPARC64_UNKNOWN_LINUX_GNU_RUNNER="/test-runner-linux sparc64" \
     CC_sparc64_unknown_linux_gnu=sparc64-linux-gnu-gcc \
     PATH=$PATH:/rust/bin
diff --git a/third_party/rust/libc/ci/docker/wasm32-unknown-emscripten/node-wrapper.sh b/third_party/rust/libc/ci/docker/wasm32-unknown-emscripten/node-wrapper.sh
index b1936f041070..3122e2e23b41 100755
--- a/third_party/rust/libc/ci/docker/wasm32-unknown-emscripten/node-wrapper.sh
+++ b/third_party/rust/libc/ci/docker/wasm32-unknown-emscripten/node-wrapper.sh
@@ -2,10 +2,14 @@
 
 set -e
 
 me=$1
 shift
 dir=$(dirname $me)
 file=$(basename $me)
 
+if echo $file | grep -q wasm; then
+  exit 0 # FIXME(rust-lang/cargo#4750)
+fi
+
 cd $dir
 exec node $file "$@"
diff --git a/third_party/rust/libc/ci/docker/x86_64-unknown-freebsd/Dockerfile b/third_party/rust/libc/ci/docker/x86_64-unknown-freebsd/Dockerfile
index 7ad3faff37c0..35f103657585 100644
--- a/third_party/rust/libc/ci/docker/x86_64-unknown-freebsd/Dockerfile
+++ b/third_party/rust/libc/ci/docker/x86_64-unknown-freebsd/Dockerfile
@@ -1,13 +1,13 @@
-FROM alexcrichton/port-prebuilt-freebsd:2017-09-16
+FROM wezm/port-prebuilt-freebsd11@sha256:43553e2265ec702ec72a63a765df333f50b1858b896e69385749e96d8624e9b0
 
 RUN apt-get update
 RUN apt-get install -y --no-install-recommends \
-  qemu genext2fs
+  qemu genext2fs xz-utils
 RUN apt-get install -y curl ca-certificates gcc
 
 ENTRYPOINT ["sh"]
 
 ENV PATH=$PATH:/rust/bin \
-    QEMU=2016-11-06/freebsd.qcow2.gz \
+    QEMU=2018-03-15/FreeBSD-11.1-RELEASE-amd64.qcow2.xz \
     CAN_CROSS=1 \
-    CARGO_TARGET_X86_64_UNKNOWN_FREEBSD_LINKER=x86_64-unknown-freebsd10-gcc
+    CARGO_TARGET_X86_64_UNKNOWN_FREEBSD_LINKER=x86_64-unknown-freebsd11-gcc
diff --git a/third_party/rust/libc/ci/docker/x86_64-unknown-linux-gnu/Dockerfile b/third_party/rust/libc/ci/docker/x86_64-unknown-linux-gnu/Dockerfile
index c5ec6826d236..6ab9c9231955 100644
--- a/third_party/rust/libc/ci/docker/x86_64-unknown-linux-gnu/Dockerfile
+++ b/third_party/rust/libc/ci/docker/x86_64-unknown-linux-gnu/Dockerfile
@@ -1,5 +1,5 @@
-FROM ubuntu:17.04
+FROM ubuntu:18.04
 RUN apt-get update
 RUN apt-get install -y --no-install-recommends \
   gcc libc6-dev ca-certificates
 ENV PATH=$PATH:/rust/bin
diff --git a/third_party/rust/libc/ci/docker/x86_64-unknown-linux-gnux32/Dockerfile b/third_party/rust/libc/ci/docker/x86_64-unknown-linux-gnux32/Dockerfile
index 1af41343e268..03f3e8e690e3 100644
--- a/third_party/rust/libc/ci/docker/x86_64-unknown-linux-gnux32/Dockerfile
+++ b/third_party/rust/libc/ci/docker/x86_64-unknown-linux-gnux32/Dockerfile
@@ -1,5 +1,5 @@
-FROM ubuntu:17.04
+FROM ubuntu:18.04
 RUN apt-get update
 RUN apt-get install -y --no-install-recommends \
   gcc-multilib libc6-dev ca-certificates
 ENV PATH=$PATH:/rust/bin
diff --git a/third_party/rust/libc/ci/docker/x86_64-unknown-linux-musl/Dockerfile b/third_party/rust/libc/ci/docker/x86_64-unknown-linux-musl/Dockerfile
index d9d651138661..6e2b7d9e5ea7 100644
--- a/third_party/rust/libc/ci/docker/x86_64-unknown-linux-musl/Dockerfile
+++ b/third_party/rust/libc/ci/docker/x86_64-unknown-linux-musl/Dockerfile
@@ -1,20 +1,20 @@
 FROM ubuntu:17.10
 
 RUN apt-get update
 RUN apt-get install -y --no-install-recommends \
   gcc make libc6-dev git curl ca-certificates
-RUN curl https://www.musl-libc.org/releases/musl-1.1.15.tar.gz | \
+RUN curl https://www.musl-libc.org/releases/musl-1.1.19.tar.gz | \
     tar xzf - && \
-    cd musl-1.1.15 && \
+    cd musl-1.1.19 && \
     ./configure --prefix=/musl-x86_64 && \
     make install -j4 && \
     cd .. && \
-    rm -rf musl-1.1.15 && \
+    rm -rf musl-1.1.19
 # Install linux kernel headers sanitized for use with musl
-    curl -L  https://github.com/sabotage-linux/kernel-headers/archive/v3.12.6-5.tar.gz | \
+RUN curl -L  https://github.com/sabotage-linux/kernel-headers/archive/v3.12.6-6.tar.gz | \
     tar xzf - && \
-    cd kernel-headers-3.12.6-5 && \
+    cd kernel-headers-3.12.6-6 && \
     make ARCH=x86_64 prefix=/musl-x86_64 install -j4 && \
     cd .. && \
-    rm -rf kernel-headers-3.12.6-5
+    rm -rf kernel-headers-3.12.6-6
 ENV PATH=$PATH:/musl-x86_64/bin:/rust/bin
diff --git a/third_party/rust/libc/ci/dox.sh b/third_party/rust/libc/ci/dox.sh
index 85e92439484c..b8ffa7dd0d07 100644
--- a/third_party/rust/libc/ci/dox.sh
+++ b/third_party/rust/libc/ci/dox.sh
@@ -11,17 +11,17 @@ TARGETS=`grep html_root_url src/lib.rs | sed 's/.*".*\/\(.*\)"/\1/'`
 rm -rf target/doc
 mkdir -p target/doc
 
 cp ci/landing-page-head.html target/doc/index.html
 
 for target in $TARGETS; do
   echo documenting $target
 
-  rustdoc -o target/doc/$target --target $target src/lib.rs --cfg dox \
+  rustdoc -o target/doc/$target --target $target src/lib.rs --cfg cross_platform_docs \
     --crate-name libc
 
   echo "<li><a href="/libc/$target/libc/index.html">$target</a></li>" \
     >> target/doc/index.html
 done
 
 cat ci/landing-page-footer.html >> target/doc/index.html
 
diff --git a/third_party/rust/libc/ci/emscripten-entry.sh b/third_party/rust/libc/ci/emscripten-entry.sh
index acaebfe8c7cb..22ae8b08a3ae 100755
--- a/third_party/rust/libc/ci/emscripten-entry.sh
+++ b/third_party/rust/libc/ci/emscripten-entry.sh
@@ -1,9 +1,9 @@
-#!/bin/bash
+#!/usr/bin/env bash
 # Copyright 2017 The Rust Project Developers. See the COPYRIGHT
 # file at the top-level directory of this distribution and at
 # http://rust-lang.org/COPYRIGHT.
 #
 # Licensed under the Apache License, Version 2.0 <LICENSE-APACHE or
 # http://www.apache.org/licenses/LICENSE-2.0> or the MIT license
 # <LICENSE-MIT or http://opensource.org/licenses/MIT>, at your
 # option. This file may not be copied, modified, or distributed
diff --git a/third_party/rust/libc/ci/ios/deploy_and_run_on_ios_simulator.rs b/third_party/rust/libc/ci/ios/deploy_and_run_on_ios_simulator.rs
index b14615036d02..95df52d76d59 100644
--- a/third_party/rust/libc/ci/ios/deploy_and_run_on_ios_simulator.rs
+++ b/third_party/rust/libc/ci/ios/deploy_and_run_on_ios_simulator.rs
@@ -118,16 +118,17 @@ fn run_app_on_simulator() {
     let output = t!(Command::new("xcrun")
                     .arg("simctl")
                     .arg("launch")
                     .arg("--console")
                     .arg("booted")
                     .arg("com.rust.unittests")
                     .output());
 
+    println!("status: {}", output.status);
     println!("stdout --\n{}\n", String::from_utf8_lossy(&output.stdout));
     println!("stderr --\n{}\n", String::from_utf8_lossy(&output.stderr));
 
     let stdout = String::from_utf8_lossy(&output.stdout);
     let passed = stdout.lines()
                        .find(|l| l.contains("PASSED"))
                        .map(|l| l.contains("tests"))
                        .unwrap_or(false);
diff --git a/third_party/rust/libc/ci/linux-s390x.sh b/third_party/rust/libc/ci/linux-s390x.sh
new file mode 100644
index 000000000000..972abeec569e
--- /dev/null
+++ b/third_party/rust/libc/ci/linux-s390x.sh
@@ -0,0 +1,18 @@
+set -ex
+
+mkdir -m 777 /qemu
+cd /qemu
+
+curl -LO https://github.com/qemu/qemu/raw/master/pc-bios/s390-ccw.img
+curl -LO http://ftp.debian.org/debian/dists/testing/main/installer-s390x/20170828/images/generic/kernel.debian
+curl -LO http://ftp.debian.org/debian/dists/testing/main/installer-s390x/20170828/images/generic/initrd.debian
+
+mv kernel.debian kernel
+mv initrd.debian initrd.gz
+
+mkdir init
+cd init
+gunzip -c ../initrd.gz | cpio -id
+rm ../initrd.gz
+cp /usr/s390x-linux-gnu/lib/libgcc_s.so.1 usr/lib/
+chmod a+w .
diff --git a/third_party/rust/libc/ci/linux-sparc64.sh b/third_party/rust/libc/ci/linux-sparc64.sh
new file mode 100644
index 000000000000..4452b120e1b6
--- /dev/null
+++ b/third_party/rust/libc/ci/linux-sparc64.sh
@@ -0,0 +1,17 @@
+set -ex
+
+mkdir -m 777 /qemu
+cd /qemu
+
+curl -LO https://cdimage.debian.org/cdimage/ports/9.0/sparc64/iso-cd/debian-9.0-sparc64-NETINST-1.iso
+7z e debian-9.0-sparc64-NETINST-1.iso boot/initrd.gz
+7z e debian-9.0-sparc64-NETINST-1.iso boot/sparc64
+mv sparc64 kernel
+rm debian-9.0-sparc64-NETINST-1.iso
+
+mkdir init
+cd init
+gunzip -c ../initrd.gz | cpio -id
+rm ../initrd.gz
+cp /usr/sparc64-linux-gnu/lib/libgcc_s.so.1 usr/lib/
+chmod a+w .
diff --git a/third_party/rust/libc/ci/run.sh b/third_party/rust/libc/ci/run.sh
index 420542a561c1..27ffc054a081 100755
--- a/third_party/rust/libc/ci/run.sh
+++ b/third_party/rust/libc/ci/run.sh
@@ -19,16 +19,23 @@ if [ "$QEMU" != "" ]; then
 
   if [ -z "${QEMU#*.gz}" ]; then
     # image is .gz : download and uncompress it
     qemufile=$(echo ${QEMU%.gz} | sed 's/\//__/g')
     if [ ! -f $tmpdir/$qemufile ]; then
       curl https://s3-us-west-1.amazonaws.com/rust-lang-ci2/libc/$QEMU | \
         gunzip -d > $tmpdir/$qemufile
     fi
+  elif [ -z "${QEMU#*.xz}" ]; then
+    # image is .xz : download and uncompress it
+    qemufile=$(echo ${QEMU%.xz} | sed 's/\//__/g')
+    if [ ! -f $tmpdir/$qemufile ]; then
+      curl https://s3-us-west-1.amazonaws.com/rust-lang-ci2/libc/$QEMU | \
+        unxz > $tmpdir/$qemufile
+    fi
   else
     # plain qcow2 image: just download it
     qemufile=$(echo ${QEMU} | sed 's/\//__/g')
     if [ ! -f $tmpdir/$qemufile ]; then
       curl https://s3-us-west-1.amazonaws.com/rust-lang-ci2/libc/$QEMU \
         > $tmpdir/$qemufile
     fi
   fi
@@ -36,17 +43,21 @@ if [ "$QEMU" != "" ]; then
   # Create a mount a fresh new filesystem image that we'll later pass to QEMU.
   # This will have a `run.sh` script will which use the artifacts inside to run
   # on the host.
   rm -f $tmpdir/libc-test.img
   mkdir $tmpdir/mount
 
   # Do the standard rigamarole of cross-compiling an executable and then the
   # script to run just executes the binary.
-  cargo build --manifest-path libc-test/Cargo.toml --target $TARGET --tests
+  cargo build \
+    --manifest-path libc-test/Cargo.toml \
+    --target $TARGET \
+    --test main
+  rm $CARGO_TARGET_DIR/$TARGET/debug/main-*.d
   cp $CARGO_TARGET_DIR/$TARGET/debug/main-* $tmpdir/mount/libc-test
   echo 'exec $1/libc-test' > $tmpdir/mount/run.sh
 
   du -sh $tmpdir/mount
   genext2fs \
       --root $tmpdir/mount \
       --size-in-blocks 100000 \
       $tmpdir/libc-test.img
@@ -63,16 +74,25 @@ if [ "$QEMU" != "" ]; then
     -drive if=virtio,file=$tmpdir/libc-test.img \
     -net nic,model=virtio \
     -net user \
     -nographic \
     -vga none 2>&1 | tee $CARGO_TARGET_DIR/out.log
   exec grep "^PASSED .* tests" $CARGO_TARGET_DIR/out.log
 fi
 
-# FIXME: x86_64-unknown-linux-gnux32 fail to compile wihout --release
+# FIXME: x86_64-unknown-linux-gnux32 fail to compile without --release
 # See https://github.com/rust-lang/rust/issues/45417
 opt=
 if [ "$TARGET" = "x86_64-unknown-linux-gnux32" ]; then
   opt="--release"
 fi
 
+# Building with --no-default-features is currently broken on rumprun because we
+# need cfg(target_vendor), which is currently unstable.
+if [ "$TARGET" != "x86_64-rumprun-netbsd" ]; then
+  cargo test $opt --no-default-features --manifest-path libc-test/Cargo.toml --target $TARGET
+fi
+# Test the #[repr(align(x))] feature if this is building on Rust >= 1.25
+if [ $(rustc --version | sed -E 's/^rustc 1\.([0-9]*)\..*/\1/') -ge 25 ]; then
+  cargo test $opt --features align --manifest-path libc-test/Cargo.toml --target $TARGET
+fi
 exec cargo test $opt --manifest-path libc-test/Cargo.toml --target $TARGET
diff --git a/third_party/rust/libc/ci/style.rs b/third_party/rust/libc/ci/style.rs
index 32e4ba772c5b..bf31576b909a 100644
--- a/third_party/rust/libc/ci/style.rs
+++ b/third_party/rust/libc/ci/style.rs
@@ -122,17 +122,19 @@ fn check_style(file: &str, path: &Path, err: &mut Errors) {
             err.error(path, i, "tab character");
         }
         if line.len() > 80 {
             err.error(path, i, "line longer than 80 chars");
         }
         if line.contains("extern \"C\"") {
             err.error(path, i, "use `extern` instead of `extern \"C\"");
         }
-        if line.contains("#[cfg(") && !line.contains(" if ") {
+        if line.contains("#[cfg(") && !line.contains(" if ")
+            && !line.contains("target_endian")
+        {
             if state != State::Structs {
                 err.error(path, i, "use cfg_if! and submodules \
                                     instead of #[cfg]");
             }
         }
 
         let line = line.trim_left();
         let is_pub = line.starts_with("pub ");
diff --git a/third_party/rust/libc/ci/test-runner-linux b/third_party/rust/libc/ci/test-runner-linux
new file mode 100755
index 000000000000..5f1fb237c28e
--- /dev/null
+++ b/third_party/rust/libc/ci/test-runner-linux
@@ -0,0 +1,23 @@
+#!/bin/sh
+
+set -e
+
+arch=$1
+prog=$2
+
+cd /qemu/init
+cp -f $2 prog
+find . | cpio --create --format='newc' --quiet | gzip > ../initrd.gz
+cd ..
+
+timeout 30s qemu-system-$arch \
+  -m 1024 \
+  -nographic \
+  -kernel kernel \
+  -initrd initrd.gz \
+  -append init=/prog > output || true
+
+# remove kernel messages
+tr -d '\r' < output | egrep -v '^\['
+
+grep PASSED output > /dev/null
diff --git a/third_party/rust/libc/src/cloudabi/aarch64.rs b/third_party/rust/libc/src/cloudabi/aarch64.rs
new file mode 100644
index 000000000000..4caa6d7bbcf4
--- /dev/null
+++ b/third_party/rust/libc/src/cloudabi/aarch64.rs
@@ -0,0 +1,4 @@
+pub type c_char = u8;
+pub type c_long = i64;
+pub type c_ulong = u64;
+pub type wchar_t = u32;
diff --git a/third_party/rust/libc/src/cloudabi/arm.rs b/third_party/rust/libc/src/cloudabi/arm.rs
new file mode 100644
index 000000000000..eca536074412
--- /dev/null
+++ b/third_party/rust/libc/src/cloudabi/arm.rs
@@ -0,0 +1,4 @@
+pub type c_char = u8;
+pub type c_long = i32;
+pub type c_ulong = u32;
+pub type wchar_t = u32;
diff --git a/third_party/rust/libc/src/cloudabi/mod.rs b/third_party/rust/libc/src/cloudabi/mod.rs
new file mode 100644
index 000000000000..e506414e3494
--- /dev/null
+++ b/third_party/rust/libc/src/cloudabi/mod.rs
@@ -0,0 +1,166 @@
+pub type in_addr_t = u32;
+pub type in_port_t = u16;
+pub type pthread_key_t = usize;
+pub type pthread_t = usize;
+pub type sa_family_t = u8;
+pub type socklen_t = usize;
+pub type time_t = i64;
+
+s! {
+    pub struct addrinfo {
+        pub ai_flags: ::c_int,
+        pub ai_family: ::c_int,
+        pub ai_socktype: ::c_int,
+        pub ai_protocol: ::c_int,
+        pub ai_addrlen: ::socklen_t,
+        pub ai_addr: *mut ::sockaddr,
+        pub ai_canonname: *mut ::c_char,
+        pub ai_next: *mut addrinfo,
+    }
+
+    pub struct in_addr {
+        pub s_addr: in_addr_t,
+    }
+
+    pub struct in6_addr {
+        pub s6_addr: [u8; 16],
+    }
+
+    pub struct pthread_attr_t {
+        __detachstate: ::c_int,
+        __stacksize: usize,
+    }
+
+    pub struct sockaddr {
+        pub sa_family: sa_family_t,
+        pub sa_data: [::c_char; 0],
+    }
+
+    pub struct sockaddr_in {
+        pub sin_family: ::sa_family_t,
+        pub sin_port: ::in_port_t,
+        pub sin_addr: ::in_addr,
+    }
+
+    pub struct sockaddr_in6 {
+        pub sin6_family: sa_family_t,
+        pub sin6_port: ::in_port_t,
+        pub sin6_flowinfo: u32,
+        pub sin6_addr: ::in6_addr,
+        pub sin6_scope_id: u32,
+    }
+
+    pub struct sockaddr_storage {
+        pub ss_family: ::sa_family_t,
+        __ss_data: [u8; 32],
+    }
+}
+
+pub const _SC_NPROCESSORS_ONLN: ::c_int = 52;
+pub const _SC_PAGESIZE: ::c_int = 54;
+
+pub const AF_INET: ::c_int = 1;
+pub const AF_INET6: ::c_int = 2;
+
+pub const EACCES: ::c_int = 2;
+pub const EADDRINUSE: ::c_int = 3;
+pub const EADDRNOTAVAIL: ::c_int = 4;
+pub const EAGAIN: ::c_int = 6;
+pub const ECONNABORTED: ::c_int = 13;
+pub const ECONNREFUSED: ::c_int = 14;
+pub const ECONNRESET: ::c_int = 15;
+pub const EEXIST: ::c_int = 20;
+pub const EINTR: ::c_int = 27;
+pub const EINVAL: ::c_int = 28;
+pub const ENOENT: ::c_int = 44;
+pub const ENOTCONN: ::c_int = 53;
+pub const EPERM: ::c_int = 63;
+pub const EPIPE: ::c_int = 64;
+pub const ETIMEDOUT: ::c_int = 73;
+pub const EWOULDBLOCK: ::c_int = EAGAIN;
+
+pub const EAI_SYSTEM: ::c_int = 9;
+
+pub const EXIT_FAILURE: ::c_int = 1;
+pub const EXIT_SUCCESS: ::c_int = 0;
+
+pub const PTHREAD_STACK_MIN: ::size_t = 1024;
+
+pub const SOCK_DGRAM: ::c_int = 128;
+pub const SOCK_STREAM: ::c_int = 130;
+
+extern {
+    pub fn arc4random_buf(buf: *const ::c_void, len: ::size_t);
+    pub fn freeaddrinfo(res: *mut addrinfo);
+    pub fn gai_strerror(errcode: ::c_int) -> *const ::c_char;
+    pub fn getaddrinfo(
+        node: *const c_char,
+        service: *const c_char,
+        hints: *const addrinfo,
+        res: *mut *mut addrinfo,
+    ) -> ::c_int;
+    pub fn getsockopt(
+        sockfd: ::c_int,
+        level: ::c_int,
+        optname: ::c_int,
+        optval: *mut ::c_void,
+        optlen: *mut ::socklen_t,
+    ) -> ::c_int;
+    pub fn posix_memalign(
+        memptr: *mut *mut ::c_void,
+        align: ::size_t,
+        size: ::size_t,
+    ) -> ::c_int;
+    pub fn pthread_attr_destroy(attr: *mut ::pthread_attr_t) -> ::c_int;
+    pub fn pthread_attr_init(attr: *mut ::pthread_attr_t) -> ::c_int;
+    pub fn pthread_attr_setstacksize(
+        attr: *mut ::pthread_attr_t,
+        stack_size: ::size_t,
+    ) -> ::c_int;
+    pub fn pthread_create(
+        native: *mut ::pthread_t,
+        attr: *const ::pthread_attr_t,
+        f: extern fn(*mut ::c_void) -> *mut ::c_void,
+        value: *mut ::c_void,
+    ) -> ::c_int;
+    pub fn pthread_detach(thread: ::pthread_t) -> ::c_int;
+    pub fn pthread_getspecific(key: pthread_key_t) -> *mut ::c_void;
+    pub fn pthread_join(
+        native: ::pthread_t,
+        value: *mut *mut ::c_void,
+    ) -> ::c_int;
+    pub fn pthread_key_create(
+        key: *mut pthread_key_t,
+        dtor: Option<unsafe extern fn(*mut ::c_void)>,
+    ) -> ::c_int;
+    pub fn pthread_key_delete(key: pthread_key_t) -> ::c_int;
+    pub fn pthread_setspecific(
+        key: pthread_key_t,
+        value: *const ::c_void,
+    ) -> ::c_int;
+    pub fn send(
+        socket: ::c_int,
+        buf: *const ::c_void,
+        len: ::size_t,
+        flags: ::c_int,
+    ) -> ::ssize_t;
+    pub fn sysconf(name: ::c_int) -> ::c_long;
+}
+
+cfg_if! {
+    if #[cfg(target_arch = "aarch64")] {
+        mod aarch64;
+        pub use self::aarch64::*;
+    } else if #[cfg(any(target_arch = "arm"))] {
+        mod arm;
+        pub use self::arm::*;
+    } else if #[cfg(any(target_arch = "x86"))] {
+        mod x86;
+        pub use self::x86::*;
+    } else if #[cfg(any(target_arch = "x86_64"))] {
+        mod x86_64;
+        pub use self::x86_64::*;
+    } else {
+        // Unknown target_arch
+    }
+}
diff --git a/third_party/rust/libc/src/cloudabi/x86.rs b/third_party/rust/libc/src/cloudabi/x86.rs
new file mode 100644
index 000000000000..2f9f39c9b9ec
--- /dev/null
+++ b/third_party/rust/libc/src/cloudabi/x86.rs
@@ -0,0 +1,4 @@
+pub type c_char = i8;
+pub type c_long = i32;
+pub type c_ulong = u32;
+pub type wchar_t = i32;
diff --git a/third_party/rust/libc/src/cloudabi/x86_64.rs b/third_party/rust/libc/src/cloudabi/x86_64.rs
new file mode 100644
index 000000000000..bb17624b1dd7
--- /dev/null
+++ b/third_party/rust/libc/src/cloudabi/x86_64.rs
@@ -0,0 +1,4 @@
+pub type c_char = i8;
+pub type c_long = i64;
+pub type c_ulong = u64;
+pub type wchar_t = i32;
